# -*- coding: utf-8 -*-

# from PortGlosa import traduzir
import os
import select
import socket
import subprocess
import sys
import threading
import time
import vlibrashook
from PortGlosa import traduzir
import threading
from queue import Queue
from subprocess import call, Popen

# lock to serialize translations output
lock = threading.Lock()

# Create the queue
setences_queue = Queue()


class Servent(threading.Thread):
    def __init__(self):
        self.__sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.__sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        threading.Thread.__init__ (self)
        # self.__sock.setblocking(1)

    def receive(self, connection, address_orca):
        print("receive")
        try:
            while True:
                data = connection.recv(1024)
                if len(data) > 0:
                    print("Received: %s %s" % (address_orca, data))
                    if (self.client.connected()):
                        data = data.decode('utf-8').encode("utf-8")
                        setences_queue.put(data)
                else:
                    break
        except Exception as e:
            print(e)
            try:
                connection.shutdown(1)
                connection.close(1)
            except Exception as e:
                print(e)

    def run(self, host = "127.0.0.1", port = 10001):
        self.client = vlibrashook.client(host, 10000) #player
        self.client.start()
        time.sleep(0.5)
        self.__sock.bind((host, port))
        self.__sock.listen(1)
        time.sleep(1)
        print("Listen: %s:%s" % (host, port))
        while True:
            print("Waiting for Orca client: %s:%s" % (host, port))
            (connection, address_orca) = self.__sock.accept()
            print("Client Orca connected!")
            # ---------------------------------------------------------------------------------
            # single thread
            # ---------------------------------------------------------------------------------
            self.receive(connection, address_orca)
            # ---------------------------------------------------------------------------------
            # multithread
            # ---------------------------------------------------------------------------------
            # t = threading.Thread(target = self.receive, args = ((connection, address_nvda)))
            # self.__threadlist.append(t)
            # t.start()

def file_exists(file_path):
    if ((os.path.isfile(file_path) == 1) and (os.path.exists(file_path) == 1)):
        return True
    else:
        return False

servent = Servent()

class Translator(threading.Thread):
    def __init__ (self):
        threading.Thread.__init__ (self)

    def do_translate(self, item):    
        with lock:
            translated = traduzir(item + "\n")
            print("Translated: %s" % (translated))
            return translated

    # The translator thread pulls an item from the queue and processes it
    def run(self):
        while True:
            try:
                if not setences_queue.empty():
                    with lock:
                        translated = traduzir(setences_queue.get()+ "\n")              
                    if (servent.client.send(translated)):
                        print("Sent: %s" % (translated))
            except Exception as e:
                print(e) 
        print("Translator is DEAD")
            

def main():
    # orca_slave = "speech.py"
    # if (not file_exists(orca_slave)):
    #     print("Orca slave not found: %s" % (orca_slave))
    #     sys.exit(1)
    # print("Run speech.py")
    # try:
    #     # subprocess.call(["python", ".\\nvda\\source\\nvda.pyw"])
    #     subprocess.call(["python", "speech.py"], shell=)
    # except:
    #     print("Erro no subprocesso Orca")
    #     sys.exit(1)

    #speech.main()

    translator = Translator()
    translator.start()
    servent.start()

    time.sleep(3)
    Popen(["orca", "--replace"])

if __name__ == "__main__":
    main()
    
