from observer import Observer
from vlibrashook import client
import time

class SpeechObserver(Observer):
    def update(self, cli, text):
        time.sleep(0.5) # wait connection
        if (cli.connected()):
           if ((not text=="blank") and cli.send(text)):
                print("Sent to VLibras: %s" % (text))
                time.sleep(0.1)
        else:
            print("Vlibras Player is not connected")
